/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.envmonitor.historydata.service.dto;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import lombok.Data;
import me.zhengjie.base.BaseDTO;
import me.zhengjie.modules.dm.envmonitor.historymodbusdata.domain.DmEnvHistoryModbusData;

import java.io.Serializable;
import java.util.Set;

/**
* @website https://el-admin.vip
* @description /
* @author lr
* @date 2022-05-19
**/
@Data
public class DmEnvHistoryDataDto extends BaseDTO implements Serializable {

    /** 主键 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

    /** 设备编号 */
    private String deviceIdentifier;

    /** 设备名称 */
    private String deviceName;

    /** 监控对象 */
    private String monitorObject;

    /** 状态 0离线 1在线 2告警 */
    private Integer deviceState;

    private Set<DmEnvHistoryModbusData> dmEnvHistoryModbusDataSet;
}