/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.envmonitor.icdevicenew.domain;

import lombok.Data;
import cn.hutool.core.bean.BeanUtil;
import io.swagger.annotations.ApiModelProperty;
import cn.hutool.core.bean.copier.CopyOptions;
import javax.persistence.*;
import javax.validation.constraints.*;
import javax.persistence.Entity;
import javax.persistence.Table;

import me.zhengjie.base.BaseEntity;
import org.hibernate.annotations.*;
import java.sql.Timestamp;
import java.io.Serializable;

/**
* @website https://el-admin.vip
* @description /
* @author wanglongda
* @date 2022-05-12
**/
@Entity
@Data
@Table(name="dm_env_ic_decive_new")
public class DmEnvIcDeciveNew extends BaseEntity implements Serializable {

    @Id
    @Column(name = "id")
    @ApiModelProperty(value = "主键")
    private Long id;

    @Column(name = "device_identifier")
    @ApiModelProperty(value = "设备编码")
    private String deviceIdentifier;

    @Column(name = "device_name")
    @ApiModelProperty(value = "设备名称")
    private String deviceName;

    @Column(name = "status")
    @ApiModelProperty(value = "状态")
    private String status;

    @Column(name = "device_port")
    @NotNull(message = "开放端口不能为空")
    @ApiModelProperty(value = "设备端口")
    private Integer devicePort;

    @Column(name = "device_topic")
    @NotBlank(message = "topic不能为空")
    @ApiModelProperty(value = "设备队列地址")
    private String deviceTopic;

    @Column(name = "device_ip")
    @NotBlank(message = "参数ip不能为空")
    @ApiModelProperty(value = "设备ip")
    private String deviceIp;

    public void copy(DmEnvIcDeciveNew source){
        BeanUtil.copyProperties(source,this, CopyOptions.create().setIgnoreNullValue(true));
    }
}