/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.modbus.channel.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import java.util.List;
import java.util.Set;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.base.BaseDTO;
import me.zhengjie.modules.dm.modbus.device.domain.DmModbusDevice;
import me.zhengjie.modules.dm.modbus.drive.domain.DmModbusDrive;

/**
* @website https://el-admin.vip
* @description /
* @author wanglongda
* @date 2022-05-20
**/
@Data
public class DmModbusChannelDto extends BaseDTO implements Serializable {

    /** 信道id */
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long channelId;

    /** 通道名称 */
    private String channelName;

    /** 串口参数 */
    private String serialPort;

    /** 波特率 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long baudRate;

    /** 数据位 */
    private String dataBits;

    /** 停止位 */
    private String stopBits;

    /** 校验位 */
    private String verifyBits;

    /** 流控制 */
    private String streamControl;

    /** 超时时间 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long timeout;

    /** 驱动id */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long driveId;

    /** 关联设备id */
    private Set<DmModbusDevice> dmModbusDevice;
}