/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.modbus.data.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.base.BaseDTO;
import me.zhengjie.modules.dm.modbus.group.domain.DmModbusGroup;

/**
* @website https://el-admin.vip
* @description /
* @author wld
* @date 2022-05-21
**/
@Data
public class DmModbusDataDto extends BaseDTO implements Serializable {

    /** 数据id */
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long dataId;

    /** 采集端（硬件）点名 */
    private String callTheRoll;

    /** 采集端描述 */
    private String describe;

    /** 采集端数据类型 */
    private String dataType;

    /** 采集端寄存器类型 */
    private String hardwareRegisterType;

    /** 采集端寄存器地址 */
    private String hardwareRegisterAddress;

    /** 采集端启用取位用逗号分隔 */
    private String isFetchBit;

    /** 采集端关联线性转换id */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long linearConversionId;

    /** 转发端(软件)寄存器类型 */
    private String softwareRegisterType;

    /** 转发端(软件)寄存器地址 */
    private String softwareRegisterAddress;

    /** 关联分组id */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long groupId;

}