/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.modbus.device.repository;

import me.zhengjie.modules.dm.modbus.device.domain.DmModbusDevice;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

import java.sql.Timestamp;

/**
* @website https://el-admin.vip
* @author wld
* @date 2022-05-20
**/
public interface DmModbusDeviceRepository extends JpaRepository<DmModbusDevice, Long>, JpaSpecificationExecutor<DmModbusDevice> {
   @Query(value = " select count(distinct(device_id)) from dm_modbus_device where  if(:status IS NOT NULL,device_status = :status,1=1 ) ",nativeQuery = true)
    Long getModbusCount(Integer status);

   @Transactional
   @Modifying
   @Query(value = "update dm_modbus_device set update_time = :timestamp,device_status = :status where device_id = :deviceId",nativeQuery = true)
    int updateDeviceStatus(@Param("timestamp") Timestamp timestamp,@Param("deviceId") Long deviceId,@Param("status") String status);
}