/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.modbus.device.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import java.util.List;
import java.util.Set;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.base.BaseDTO;
import me.zhengjie.modules.dm.modbus.channel.domain.DmModbusChannel;
import me.zhengjie.modules.dm.modbus.group.domain.DmModbusGroup;

/**
* @website https://el-admin.vip
* @description /
* @author wld
* @date 2022-05-20
**/
@Data
public class DmModbusDeviceDto extends BaseDTO implements Serializable {

    /** 设备id */
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long deviceId;

    /** 设备名称 */
    private String deviceName;

    /** 从站站号 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long salveStationNumber;

    /** 采集通讯站号 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long stationNumber;

    /** 采集通讯请求帧间隔(毫秒) */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long requestFrameInterval;

    /** 采集通讯写值刷新间隔(毫秒) */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long writeValueRefreshInterval;

    /** 采集通讯2字节整数顺序 */
    private String twoByteIntOrder;

    /** 采集通讯4字节整数顺序 */
    private String fourByteIntOrder;

    /** 单精度浮点数顺序 */
    private String floatOrder;

    /** 批量传输模拟量组包间隔 */
    private String analogQuantityGroupPacketInterval;

    /** 批量传输模拟量组包最大长度 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long analogQuantityGroupPacketMaxlength;

    /** 批量传输数字量组包间隔 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long digitalQuantityGroupPacketInterval;

    /** 批量传输数字量组包最大长度 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long digitalQuantityGroupPacketMaxlength;

    /** 信道id */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long channelId;

    /** 关联的分组 */
    private Set<DmModbusGroup> dmModbusGroup;

    private String deviceStatus;
}